local scaled = require "scaled"

local gameover = {}

local game_objects = {}

local bungee_font = love.graphics.newFont(
   "/fonts/Bungee_Inline/BungeeInline-Regular.ttf", 30 )

function gameover.enter( prev_state, ... )
   game_objects = ...
   if USING_ARCADE then
      Arcade.gameover()
   end
end

function gameover.update( dt )
end

function gameover.draw()
   for _, obj in pairs( game_objects ) do
      if type(obj) == "table" and obj.draw then
         obj.draw(obj)
      end
   end
   local oldfont = love.graphics.getFont()
   love.graphics.setFont( bungee_font )
   local r, g, b, a = love.graphics.getColor( )
   love.graphics.setColor( 1, 1, 1, 0.9 )
   scaled.graphics.printf( "GAME OVER",
      200,
      300,
      400,
      "center" )
   love.graphics.setFont( oldfont )
   love.graphics.setColor( r, g, b, a )
end

function gameover.keyreleased( key, code )
   if key == "return" or key == "space" or key == "g" then
      gamestates.set_state( "menu" )
   elseif key == 'escape' then
      love.event.quit()
   end    
end

function gameover.exit()
   game_objects = nil 
end

return gameover
