local scaled = { graphics = {}, mouse = {} }


function scaled.change(s, fullscreen)
   love_window_width = 1066
   love_window_height = 600
   scale = s

   if fullscreen then
      fullscreen = true
      love.window.setMode(0, 0, {fullscreen=fullscreen, vsync=vsync})
      gamewidth = love.graphics.getWidth()
      gameheight = love.graphics.getHeight()
      scale = gamewidth / love_window_width
      if (scale > gameheight / love_window_height) then
         scale = gameheight / love_window_height
      end
   end

   love.window.setMode(love_window_width*scale, love_window_height*scale, {fullscreen=fullscreen, vsync=vsync})

   gamewidth = love.graphics.getWidth()
   gameheight = love.graphics.getHeight()
end

function scaled.graphics.draw(img, quad, x, y)
   love.graphics.draw(img, quad, (x + 5) * scale, y * scale, 0, scale, scale);
end

function scaled.graphics.rectangle(mode, x, y, w, h)
   love.graphics.rectangle(mode, (x + 5) * scale, y * scale, w *scale, h * scale);
end

function scaled.graphics.print(text, x, y)
   love.graphics.print(text, (x + 5) * scale, y * scale, 0, scale, scale)
end

function scaled.graphics.printf(text, x, y, limit, align)
   love.graphics.printf(text, (x + 5) * scale, y * scale, limit, align, 0, scale, scale)
end

function scaled.graphics.getHeight()
   return love_window_height
end

function scaled.mouse.getPosition()
   local x, y = love.mouse.getPosition()
   x = x / scale - 5
   y = y / scale
   return x, y
end

return scaled
